---
title: MouseEvent()
slug: Web/API/MouseEvent/MouseEvent
tags:
  - API
  - Constructor
  - DOM
  - MouseEvent
  - Reference
  - events
---
<p id="Summary">{{APIRef("DOM Events")}}</p>

<p>The <strong><code>MouseEvent()</code></strong> constructor creates a new {{domxref("MouseEvent")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"> <em>event</em> = new MouseEvent(<em>typeArg</em>, <em>mouseEventInit</em>);</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><em>typeArg</em></dt>
 <dd>Is a {{domxref("DOMString")}} representing the name of the event.</dd>
 <dt><em>mouseEventInit</em> {{optional_inline}}</dt>
</dl>

<dl>
 <dd>Is a <code>MouseEventInit</code> dictionary, having the following fields:

 <ul>
  <li><code>"screenX"</code>, optional and defaulting to <code>0</code>, of type <code>long</code>, that is the horizontal position of the mouse event on the user's screen; setting this value doesn't move the mouse pointer.</li>
  <li><code>"screenY"</code>, optional and defaulting to <code>0</code>, of type <code>long</code>, that is the vertical position of the mouse event on the user's screen; setting this value doesn't move the mouse pointer.</li>
  <li><code>"clientX"</code>, optional and defaulting to <code>0</code>, of type <code>long</code>, that is the horizontal position of the mouse event on the client window of user's screen; setting this value doesn't move the mouse pointer.</li>
  <li><code>"clientY"</code>, optional and defaulting to <code>0</code>, of type <code>long</code>, that is the vertical position of the mouse event on the client window of the user's screen; setting this value doesn't move the mouse pointer.</li>
  <li><code>"ctrlKey"</code>, optional and defaulting to <code>false</code>, of type {{jsxref("Boolean")}}, that indicates if the <kbd>ctrl</kbd> key was simultaneously pressed.</li>
  <li><code>"shiftKey"</code>, optional and defaulting to <code>false</code>, of type {{jsxref("Boolean")}}, that indicates if the <kbd>shift</kbd> key was simultaneously pressed.</li>
  <li><code>"altKey"</code>, optional and defaulting to <code>false</code>, of type {{jsxref("Boolean")}}, that indicates if the <kbd>alt</kbd> key was simultaneously pressed.</li>
  <li><code>"metaKey"</code>, optional and defaulting to <code>false</code>, of type {{jsxref("Boolean")}}, that indicates if the <kbd>meta</kbd> key was simultaneously pressed.</li>
  <li><code>"button"</code>, optional and defaulting to <code>0</code>, of type <code>short</code>, that describes which button is pressed during events related to the press or release of a button:
   <table class="standard-table">
    <thead>
     <tr>
      <th scope="col">Value</th>
      <th scope="col">Meaning</th>
     </tr>
    </thead>
    <tbody>
     <tr>
      <td><code>0</code></td>
      <td>Main button pressed (usually the left button) or un-initialized</td>
     </tr>
     <tr>
      <td><code>1</code></td>
      <td>Auxiliary button pressed (usually the middle button)</td>
     </tr>
     <tr>
      <td><code>2</code></td>
      <td>Secondary button pressed (usually the right button)</td>
     </tr>
    </tbody>
   </table>
  </li>
  <li><code>"buttons"</code>, optional and defaulting to <code>0</code>, of type <code>unsigned short</code>, that describes which buttons are pressed when the event is launched:
   <table class="standard-table">
    <thead>
     <tr>
      <th scope="col">Bit-field value</th>
      <th scope="col">Meaning</th>
     </tr>
    </thead>
    <tbody>
     <tr>
      <td><code>0</code></td>
      <td>No button pressed</td>
     </tr>
     <tr>
      <td><code>1</code></td>
      <td>Main button pressed (usually the left button)</td>
     </tr>
     <tr>
      <td><code>2</code></td>
      <td>Secondary button pressed (usually the right button)</td>
     </tr>
     <tr>
      <td><code>4</code></td>
      <td>Auxiliary button pressed (usually the middle button)</td>
     </tr>
    </tbody>
   </table>
  </li>
  <li><code>"relatedTarget"</code>, optional and defaulting to <code>null</code>, of type {{domxref("EventTarget")}}, that is the element just left (in case of  a {{event("mouseenter")}} or {{event("mouseover")}}) or is entering (in case of a {{event("mouseout")}} or {{event("mouseleave")}}).</li>
  <li><code>"region"</code>, optional and defaulting to <code>null</code>, of type {{domxref("DOMString")}}, is the id of the hit region affected by the event. The absence of any hit region is affected, is represented by the <code>null</code> value.</li>
 </ul>

 <p>In some implementations, passing anything other than a number for the screen and client fields will throw a <code>TypeError</code>.</p>

 <div class="note">
 <p><em>The <code>MouseEventInit</code></em><em> dictionary also accepts fields from {{domxref("UIEvent.UIEvent", "UIEventInit")}} and from {{domxref("Event.Event", "EventInit")}} dictionaries.</em></p>
 </div>
 </dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSSOM View', '#extensions-to-the-mouseevent-interface', 'MouseEvent')}}</td>
   <td>{{Spec2('CSSOM View')}}</td>
   <td>Redefines screen and client fields long to double.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Events','#interface-MouseEvent','MouseEvent()')}}</td>
   <td>{{Spec2('DOM3 Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MouseEvent.MouseEvent")}}</p>

<h2 id="Polyfill">Polyfill</h2>

<p>You can polyfill the <code>MouseEvent()</code> constructor functionality in Internet Explorer 9 and higher with the following code:</p>

<pre class="brush: js">(function (window) {
  try {
    new MouseEvent('test');
    return false; // No need to polyfill
  } catch (e) {
		// Need to polyfill - fall through
  }

    // Polyfills DOM4 MouseEvent
	var MouseEventPolyfill = function (eventType, params) {
		params = params || { bubbles: false, cancelable: false };
		var mouseEvent = document.createEvent('MouseEvent');
		mouseEvent.initMouseEvent(eventType,
			params.bubbles,
			params.cancelable,
			window,
			0,
			params.screenX || 0,
			params.screenY || 0,
			params.clientX || 0,
			params.clientY || 0,
			params.ctrlKey || false,
			params.altKey || false,
			params.shiftKey || false,
			params.metaKey || false,
			params.button || 0,
			params.relatedTarget || null
		);

		return mouseEvent;
	}

	MouseEventPolyfill.prototype = Event.prototype;

	window.MouseEvent = MouseEventPolyfill;
})(window);
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MouseEvent")}}, the interface of the objects it constructs.</li>
</ul>
